> For clean Markdown of any page, append .md to the page URL.
> For a complete documentation index, see https://help.sigmacomputing.com/llms.txt.
> For AI client integration (Claude Code, Cursor, etc.), connect to the MCP server at https://help.sigmacomputing.com/_mcp/server.

# Set a user attribute for users

POST https://api.sigmacomputing.com/v2/user-attributes/{userAttributeId}/users
Content-Type: application/json

Assign and set the value of a specific user attribute for one or more users.

  ### Usage notes
  - Retrieve the **userAttributeId** by calling the [/v2/user-attributes](https://help.sigmacomputing.com/reference/list-user-attributes) endpoint.
  - Specify one or more users by userId. Retrieve the **userId** by calling the [/v2/members](https://help.sigmacomputing.com/reference/list-members) endpoint and using the `memberId` included in the response.
    

Reference: https://help.sigmacomputing.com/reference/set-user-attribute-for-users

## Authentication

- OAuth2 — send the obtained token as `Authorization: Bearer <token>`

## Servers

- `https://api.sigmacomputing.com` (Server for GCP (US) hosted organizations, default)
- `https://api.sa.gcp.sigmacomputing.com` (Server for GCP (KSA) hosted organizations)
- `https://aws-api.sigmacomputing.com` (Server for AWS US (West) hosted organizations)
- `https://api.us-a.aws.sigmacomputing.com` (Server for AWS US (East) hosted organizations)
- `https://api.ca.aws.sigmacomputing.com` (Server for AWS Canada hosted organizations)
- `https://api.eu.aws.sigmacomputing.com` (Server for AWS Europe hosted organizations)
- `https://api.au.aws.sigmacomputing.com` (Server for AWS Australia and APAC hosted organizations)
- `https://api.uk.aws.sigmacomputing.com` (Server for AWS UK hosted organizations)
- `https://api.us.azure.sigmacomputing.com` (Server for Azure US hosted organizations)
- `https://api.eu.azure.sigmacomputing.com` (Server for Azure Europe hosted organizations)
- `https://api.ca.azure.sigmacomputing.com` (Server for Azure Canada hosted organizations)
- `https://api.uk.azure.sigmacomputing.com` (Server for Azure United Kingdom hosted organizations)
- `https://api.au.azure.sigmacomputing.com` (Server for Azure Australia hosted organizations)

## Request

### Path parameters

- `userAttributeId` (string, required)

### Body (application/json)

- `assignments` (list of object, required)
  - `userId` (string, required) — Unique identifier of the user.
  - `value` (object, required) — The value of the user attribute
    - `type` (enum, required) — Type of user attribute.
      - Allowed values: `string`
    - `val` (string, required) — Value of the user attribute.

## Response

### 200

The response body.

## Examples

**Request**

```json
{
  "assignments": [
    {
      "userId": "mTwJbaYKQbBexvF4ZWGeRxuAmbGKm",
      "value": {
        "type": "string",
        "val": "foo"
      }
    },
    {
      "userId": "mTwJbaYKQbBexvF4ZWGeRxuAmbGKn",
      "value": {
        "type": "string",
        "val": "bar"
      }
    }
  ]
}
```

**Response**

```json
{}
```

**SDK Code**

```python Request Example
import requests

url = "https://api.sigmacomputing.com/v2/user-attributes/userAttributeId/users"

payload = { "assignments": [
        {
            "userId": "mTwJbaYKQbBexvF4ZWGeRxuAmbGKm",
            "value": {
                "type": "string",
                "val": "foo"
            }
        },
        {
            "userId": "mTwJbaYKQbBexvF4ZWGeRxuAmbGKn",
            "value": {
                "type": "string",
                "val": "bar"
            }
        }
    ] }
headers = {
    "Authorization": "<token>.",
    "Content-Type": "application/json"
}

response = requests.post(url, json=payload, headers=headers)

print(response.json())
```

```javascript Request Example
const url = 'https://api.sigmacomputing.com/v2/user-attributes/userAttributeId/users';
const options = {
  method: 'POST',
  headers: {Authorization: '<token>.', 'Content-Type': 'application/json'},
  body: '{"assignments":[{"userId":"mTwJbaYKQbBexvF4ZWGeRxuAmbGKm","value":{"type":"string","val":"foo"}},{"userId":"mTwJbaYKQbBexvF4ZWGeRxuAmbGKn","value":{"type":"string","val":"bar"}}]}'
};

try {
  const response = await fetch(url, options);
  const data = await response.json();
  console.log(data);
} catch (error) {
  console.error(error);
}
```

```go Request Example
package main

import (
	"fmt"
	"strings"
	"net/http"
	"io"
)

func main() {

	url := "https://api.sigmacomputing.com/v2/user-attributes/userAttributeId/users"

	payload := strings.NewReader("{\n  \"assignments\": [\n    {\n      \"userId\": \"mTwJbaYKQbBexvF4ZWGeRxuAmbGKm\",\n      \"value\": {\n        \"type\": \"string\",\n        \"val\": \"foo\"\n      }\n    },\n    {\n      \"userId\": \"mTwJbaYKQbBexvF4ZWGeRxuAmbGKn\",\n      \"value\": {\n        \"type\": \"string\",\n        \"val\": \"bar\"\n      }\n    }\n  ]\n}")

	req, _ := http.NewRequest("POST", url, payload)

	req.Header.Add("Authorization", "<token>.")
	req.Header.Add("Content-Type", "application/json")

	res, _ := http.DefaultClient.Do(req)

	defer res.Body.Close()
	body, _ := io.ReadAll(res.Body)

	fmt.Println(res)
	fmt.Println(string(body))

}
```

```ruby Request Example
require 'uri'
require 'net/http'

url = URI("https://api.sigmacomputing.com/v2/user-attributes/userAttributeId/users")

http = Net::HTTP.new(url.host, url.port)
http.use_ssl = true

request = Net::HTTP::Post.new(url)
request["Authorization"] = '<token>.'
request["Content-Type"] = 'application/json'
request.body = "{\n  \"assignments\": [\n    {\n      \"userId\": \"mTwJbaYKQbBexvF4ZWGeRxuAmbGKm\",\n      \"value\": {\n        \"type\": \"string\",\n        \"val\": \"foo\"\n      }\n    },\n    {\n      \"userId\": \"mTwJbaYKQbBexvF4ZWGeRxuAmbGKn\",\n      \"value\": {\n        \"type\": \"string\",\n        \"val\": \"bar\"\n      }\n    }\n  ]\n}"

response = http.request(request)
puts response.read_body
```

```java Request Example
import com.mashape.unirest.http.HttpResponse;
import com.mashape.unirest.http.Unirest;

HttpResponse<String> response = Unirest.post("https://api.sigmacomputing.com/v2/user-attributes/userAttributeId/users")
  .header("Authorization", "<token>.")
  .header("Content-Type", "application/json")
  .body("{\n  \"assignments\": [\n    {\n      \"userId\": \"mTwJbaYKQbBexvF4ZWGeRxuAmbGKm\",\n      \"value\": {\n        \"type\": \"string\",\n        \"val\": \"foo\"\n      }\n    },\n    {\n      \"userId\": \"mTwJbaYKQbBexvF4ZWGeRxuAmbGKn\",\n      \"value\": {\n        \"type\": \"string\",\n        \"val\": \"bar\"\n      }\n    }\n  ]\n}")
  .asString();
```

```php Request Example
<?php
require_once('vendor/autoload.php');

$client = new \GuzzleHttp\Client();

$response = $client->request('POST', 'https://api.sigmacomputing.com/v2/user-attributes/userAttributeId/users', [
  'body' => '{
  "assignments": [
    {
      "userId": "mTwJbaYKQbBexvF4ZWGeRxuAmbGKm",
      "value": {
        "type": "string",
        "val": "foo"
      }
    },
    {
      "userId": "mTwJbaYKQbBexvF4ZWGeRxuAmbGKn",
      "value": {
        "type": "string",
        "val": "bar"
      }
    }
  ]
}',
  'headers' => [
    'Authorization' => '<token>.',
    'Content-Type' => 'application/json',
  ],
]);

echo $response->getBody();
```

```csharp Request Example
using RestSharp;

var client = new RestClient("https://api.sigmacomputing.com/v2/user-attributes/userAttributeId/users");
var request = new RestRequest(Method.POST);
request.AddHeader("Authorization", "<token>.");
request.AddHeader("Content-Type", "application/json");
request.AddParameter("application/json", "{\n  \"assignments\": [\n    {\n      \"userId\": \"mTwJbaYKQbBexvF4ZWGeRxuAmbGKm\",\n      \"value\": {\n        \"type\": \"string\",\n        \"val\": \"foo\"\n      }\n    },\n    {\n      \"userId\": \"mTwJbaYKQbBexvF4ZWGeRxuAmbGKn\",\n      \"value\": {\n        \"type\": \"string\",\n        \"val\": \"bar\"\n      }\n    }\n  ]\n}", ParameterType.RequestBody);
IRestResponse response = client.Execute(request);
```

```swift Request Example
import Foundation

let headers = [
  "Authorization": "<token>.",
  "Content-Type": "application/json"
]
let parameters = ["assignments": [
    [
      "userId": "mTwJbaYKQbBexvF4ZWGeRxuAmbGKm",
      "value": [
        "type": "string",
        "val": "foo"
      ]
    ],
    [
      "userId": "mTwJbaYKQbBexvF4ZWGeRxuAmbGKn",
      "value": [
        "type": "string",
        "val": "bar"
      ]
    ]
  ]] as [String : Any]

let postData = JSONSerialization.data(withJSONObject: parameters, options: [])

let request = NSMutableURLRequest(url: NSURL(string: "https://api.sigmacomputing.com/v2/user-attributes/userAttributeId/users")! as URL,
                                        cachePolicy: .useProtocolCachePolicy,
                                    timeoutInterval: 10.0)
request.httpMethod = "POST"
request.allHTTPHeaderFields = headers
request.httpBody = postData as Data

let session = URLSession.shared
let dataTask = session.dataTask(with: request as URLRequest, completionHandler: { (data, response, error) -> Void in
  if (error != nil) {
    print(error as Any)
  } else {
    let httpResponse = response as? HTTPURLResponse
    print(httpResponse)
  }
})

dataTask.resume()
```